-- Load Libraries
local ldb = LibStub:GetLibrary("LibDataBroker-1.1")

-- Melee/Range Stats
local Melee_AP_Frame = ldb:NewDataObject("StatsNow - Melee Attack Power", {type = "data source", label = "Melee Attack Power", text = "", icon = "Interface\\Icons\\Ability_MeleeDamage"})
local Melee_Crit_Frame = ldb:NewDataObject("StatsNow - Melee Crit", {type = "data source", label = "Melee Crit", text = "", icon = "Interface\\Icons\\Ability_Warrior_ShieldBreak"})
local Expertise_Frame = ldb:NewDataObject("StatsNow - Expertise", {type = "data source", label = "Expertise", text = "", icon = "Interface\\Icons\\Ability_Warrior_Challange"})
local Melee_Armor_Pen_Frame = ldb:NewDataObject("StatsNow - Melee Armor Penetration", {type = "data source", label = "Melee Armor Penetration", text = "", icon = "Interface\\Icons\\Ability_Hunter_PiercingShots"})
local Melee_Hit_Frame = ldb:NewDataObject("StatsNow - Melee Hit", {type = "data source", label = "Melee Hit", text = "", icon = "Interface\\Icons\\Spell_ChargePositive"})
local Melee_Haste_Frame = ldb:NewDataObject("StatsNow - Melee Haste", {type = "data source", label = "Melee Haste", text = "", icon = "Interface\\Icons\\Ability_Rogue_SliceDice"})
local Weapon_Speed_Frame = ldb:NewDataObject("StatsNow - Weapon Speed", {type = "data source", label = "Weapon Speed", text = "", icon = "Interface\\Icons\\Ability_steelmelee"})

-- Melee Frames
local Melee_AP = CreateFrame("frame")
local Melee_Crit = CreateFrame("frame")
local Expertise = CreateFrame("frame")
local Melee_Armor_Pen = CreateFrame("frame")
local Melee_Hit = CreateFrame("frame")
local Melee_Haste = CreateFrame("frame")
local Weapon_Speed = CreateFrame("frame")

-- Data Input
Melee_Haste:SetScript("OnUpdate", function(self, elap)
	local Total_Melee_Haste = GetCombatRatingBonus("18")
	Melee_Haste_Frame.text = string.format("%.2f%%", Total_Melee_Haste)
end)

Melee_Hit:SetScript("OnUpdate", function(self, elap)
	local Total_Hit = GetCombatRatingBonus("6")
	Melee_Hit_Frame.text = string.format("%.2f%%", Total_Hit)
end)

Melee_AP:SetScript("OnUpdate", function(self, elap)
	local base, posBuff, negBuff = UnitAttackPower("player")
	local Melee_AP = base + posBuff + negBuff
	Melee_AP_Frame.text = Melee_AP
end)

Melee_Crit:SetScript("OnUpdate", function(self, elap)
	local Melee_Crit = GetCritChance("player")
	Melee_Crit_Frame.text = string.format("%.2f%%", Melee_Crit)
end)

Expertise:SetScript("OnUpdate", function(self, elap)
	local Expertise = GetCombatRatingBonus("24")
	Expertise_Frame.text = string.format("%.2f%%", Expertise)
end)

Melee_Armor_Pen:SetScript("OnUpdate", function(self, elap)
	local Melee_Armor_Pen = GetCombatRatingBonus("25")
	Melee_Armor_Pen_Frame.text = string.format("%.2f%%", Melee_Armor_Pen)
end)

Weapon_Speed:SetScript("OnUpdate", function(self, elap)
	local mainSpeed, offSpeed = UnitAttackSpeed("player");
	local MH = mainSpeed
	local OH = offSpeed
	if OH = "" then
		Weapon_Speed_Frame.text = string.format("%.2f", MH)
	else
		Weapon_Speed_Frame.text = string.format("%.2f, %s, %.2f", MH, "/", OH)
	end
end)